﻿Imports OpenEEG
Imports System.Drawing.Drawing2D

Public Class Form1
    Dim eeg As OpenEEGInterface
    Dim plotData() As DataFrame

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Set window size
        Width = 420
        Height = 310
        ' Initialise eeg interface
        eeg = New OpenEEGInterface("COM1", 128)
        ' Add event handler to respond when new blocks are ready
        AddHandler eeg.DataBlockReady, AddressOf OnData
    End Sub

    Private Sub OnData(ByVal sender As Object, ByVal e As EventArgs)
        ' When a new block is ready, copy to plotData and refresh display
        eeg.GetBlock(plotData)
        Invalidate()
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        ' Draw plot outlines
        e.Graphics.DrawRectangle(Pens.Black, 10, 10, 3 * 128, 100)
        e.Graphics.DrawRectangle(Pens.Black, 10, 160, 3 * 128, 100)
        If (Not (IsArray(plotData))) Then
            Return
        End If
        Dim path As New GraphicsPath()
        ' Draw plots of data for channel 0 and channel 1
        For m = 0 To 1
            path.StartFigure()
            For n = 0 To plotData.Count - 2
                path.AddLine(10 + n * 3, 150 * m + 60 + CSng(plotData(n).samples(m) / 20), 10 + (n + 1) * 3, 150 * m + 60 + CSng(plotData(n + 1).samples(m) / 20))
            Next
        Next
        e.Graphics.DrawPath(New Pen(Color.FromArgb(255, 0, 180, 100), 2), path)
    End Sub
End Class
